User ordering by name is incorrect for french language

2024-01-23 15:33 - philippe lhardy

Status: New Start date:  

Priority: Normal Due date:  

Assignee:  % Done: 0%

Category: Accounts / authentication Estimated time: 0.00 hour

Target version: Candidate for next major release   

Resolution:  Affected version:  

Description

by example in user list to pick for ticket assignement users with accentuated characters don't follow natural french ordering.

It should normalize name with accentuated characters like éè to correponding non accenutated letter prior of ordering.

when the list is very long it can lead to the false impression that user is not registered.

in redmine : Claire < Clovis < Clément < Constantin < Cyril < Céline

while we would expect :  Céline (Celine) < Claire < Clément (Clement) < Clovis < Constantin < Cyril

History

#1 - 2024-01-23 15:37 - philippe lhardy

I noticed that some features have been requested for user ordering like :

https://www.redmine.org/issues/19484

https://www.redmine.org/issues/22497

#2 - 2024-01-23 15:44 - philippe lhardy

- File Capture d’écran du 2024-01-23 15-42-09.png added

Example of listing in drop down list of assignee.

#3 - 2024-01-23 15:49 - philippe lhardy

- File Capture d’écran du 2024-01-23 15-46-45.png added

This problem does not show in listing of project members, so this bug depends on context and redmine already knows how to deal correctly with

accentuated ordering.

#4 - 2024-01-23 15:55 - philippe lhardy

- File Capture d’écran du 2024-01-23 15-53-29.png added

watcher ordering is different from the list given in search for those.

#5 - 2024-01-23 18:29 - philippe lhardy

It is possible to fix watcher ordering by replacing sort by in sorted app/helpers/issues_helper.rb

diff --git a/app/helpers/issues_helper.rb b/app/helpers/issues_helper.rb

index 2453c1204..ca5c163e4 100644

--- a/app/helpers/issues_helper.rb

+++ b/app/helpers/issues_helper.rb

@@ -467,7 +467,7 @@ module IssuesHelper

     users = issue.watcher_users.select{|u| u.status == User::STATUS_ACTIVE}

     assignable_watchers = issue.project.principals.assignable_watchers.limit(21)

     if assignable_watchers.size <= 20

-      users += assignable_watchers.sort

+      users += assignable_watchers.sorted

     end

     users.uniq

   end
#6 - 2024-01-23 19:40 - philippe lhardy

- File user_sorting_20240123193437.patch added

Here my patch to fix assignee drop_down_list and watchers sorting in french.

might apply to any language where ascii/utf-8 ordering is not same than characters comparisons.

#7 - 2024-01-24 05:26 - Go MAEDA

- Target version set to Candidate for next major release

#8 - 2024-02-08 00:50 - Bolesław Kalinowski

Patch user_sorting_20240123193437.patch doesn't correct error for Polish language.

#9 - 2024-02-08 08:32 - philippe lhardy

Hi Boleslaw,

This patch assumption is that database ordering is fine while ruby ordering is not, patch is to always use sorted on active record and not sort on

string. It might differ depending on database, i did my test on postgres.

Please open a specific defect for polish language with a set of example of expected ordering and link this new issue here.

Regards

Philippe.

#10 - 2024-02-08 11:02 - Bolesław Kalinowski

Sorry, my mistake.

P.S.

Why, when I open https://www.redmine.org/attachments/31850, and compare with 'issues_helper.rb' (Redmine 5.1 stable) I see different line

numbering?

Files

Capture d’écran du 2024-01-23 15-42-09.png 48.2 KB 2024-01-23 philippe lhardy

Capture d’écran du 2024-01-23 15-46-45.png 53.7 KB 2024-01-23 philippe lhardy

Capture d’écran du 2024-01-23 15-53-29.png 136 KB 2024-01-23 philippe lhardy

user_sorting_20240123193437.patch 2.07 KB 2024-01-23 philippe lhardy

Powered by TCPDF (www.tcpdf.org)

2024-05-17 2/2

https://www.redmine.org/attachments/31850
http://www.tcpdf.org

